//////
///// Script for the CrossDrop system. Dedicated to detecting file drops.
////


// TODO - options panel
// TODO - time out files
// TODO - handle multiple files
// TODO - user feedback area?


//___ Globals ___//

// TODO - fix this issue
// temporary file holder system for upload slot
var giveManager = {
	// flag to prevent give button spamming while uploading
	canGive: true,
	currentFile: null,
	fileEvent: null,

	// File getters/ setters
	setFile : function (file) {
		this.currentFile = file;
	},
	getFile : function () {
		return this.currentFile;
	},
	// Event getter/setters
	setEvent : function (e) {
		this.fileEvent = e;
	},
	getEvent : function () {
		return this.fileEvent;
	}
}

// when user uploads a video, this object holds the servers filepath response
var getManager = {
	// flag to prevent get button spamming while downloading
	canGet: true,
	// after upload is done, the unqique id is placed in the "Get It" placeholder
	getItValue: "",
	// the server returns the filepath for the given id
	filePath: "",	// TODO - check to see if i need this

	// get the user-entered placeholder text and test to see if it's in the correct format
	updatePlaceholder: function () {
		var input = $(".number-input").val();
		if(input.length == 6) {
			// make sure our input only contains letters or numbers
			if(/^[a-zA-Z0-9]+$/.test(input)) {
				// if we have valid input, update the placeholder variable
				this.getItValue = input;
				return true;
			}else
				return false;
		}else 
			return false;
	}
}

//___ Methods ___//

/*
 * Set dragging event listeners to the drop zone.
 */
function bindHandlers () {
	$(".dropzone-text").on("dragover", function (e) {
		e.preventDefault();
		e.stopPropagation();

		// provide user feedback
		$(".dropzone-text").css("background-color", "Salmon");
	});

	$(".dropzone-text").on("dragcenter", function (e) {
		e.preventDefault();
		e.stopPropagation();
	});

	$(".dropzone-text").on("drop", function (e) {
		if(giveManager.canGive) {
			// TODO - fix multiple drops before you hit upload (maybe a feature?)
			console.log("File Dropped...");

			if(e.originalEvent.dataTransfer) {
				if(e.originalEvent.dataTransfer.files.length) {
					e.preventDefault();
					e.stopPropagation();

					// save file information for later use (when user hits upload)
					giveManager.setFile(e.originalEvent.dataTransfer.files[0]);
					// save event information for later use
					giveManager.setEvent(e);

					// update the text placeholder
					updateGiveText(giveManager.getFile());
					
					// only bind the button click if we have dropped a file
					$(".upload-button").on("click", function () {
						if(giveManager.canGive) {
							// upload the file with AJAX
							uploadFile(giveManager.getEvent(), giveManager.getFile());
						}else{
							console.log("Please wait until your previous upload finishes before starting another.");
						}
					});
				}
			}
		}else {
			console.log("Please wait until your previous upload finishes before starting another.");
		}
	});

	// TODO - fix mouse moving off screen color
	$("#lower-container").mouseout(function () {
		// back to original color
		$("#lower-container").css("background-color", "FloralWhite");
	});

	// set the click handler for the download button
	$(".download-button").on("click", function () {
		// if the user is not already downloading a file
		if(getManager.canGet) {
			// if the user entered a valid input code
			if(getManager.updatePlaceholder()) {
				// query the database to find that code
				requestFilePath(getManager.getItValue);
			}
		}else {
			console.log("Please wait until your previous download finishes before starting another.");
		}
	});
}


/*
 * Update the text information to show the file name.
 */
function updateGiveText (file) {
	// Change drop location text to show the uploaded file name
	$(".dropzone-text").fadeOut("slow", function () {
		// change only the text inside the element
		// TODO - fix text wrapping of file name
		$(".dropzone-text").text(file.name);
		$(".dropzone-text").css("border", "none");
	});
	$(".dropzone-text").fadeIn();
}

/*
 * Update download progress.
 */
function updateUploadProgress (progress) {
	// change the "Give It" text to reflect the current upload progress
	$(".dropzone-text").text(progress + "%");
}

/*
 * Update download progress.
 */
function updateGetText (retrievalCode) {
	// change the "Give It" text to reflect the current upload progress
	$(".number-input").attr("placeholder", retrievalCode);
}

/*
 * Upload the file to the database with AJAX.
 */
function uploadFile (event, file) {

	// once user hits upload, wait until it is done before allowing them to push the button again
	giveManager.canGive = false;

	// stay on this page
	event.preventDefault();

	// TODO - Server validation? Prevent cross-origin stuff
	console.log("Starting the Upload Process");

	// create new form container
	var formData = new FormData();
	formData.append("file", file);

		$.ajax({
			type: "POST",
			// url of script on the server
			url: "http://130.111.220.27/~kfowlie/cross_drop/file_handler.php",
			data: formData,
			// dataType: "json",
			processData: false,
			contentType: false,
			// handle AJAX errors
			error: errorHandler,

			xhr: function() {
			        var xhr = new window.XMLHttpRequest();
			        xhr.upload.addEventListener("progress", function(evt) {
			            if (evt.lengthComputable) {
			                var percentComplete = evt.loaded / evt.total;
			                // Do something with upload progress
			                updateUploadProgress(Math.round(percentComplete * 100));
			            }
			        }, false);

			        return xhr;
			    }
			}).done(function(data) {
				// display retrieval code
				updateGetText(data);
				// allow user to hit upload button again
				giveManager.canGive = true;
			});
}

/*
 * Called when the user clicks the download button
 */
function requestFilePath (uniqueId) {

	// TODO - set flags to prevet download button spam
	getManager.canGet = false;

	// stay on this page
	event.preventDefault();

	// TODO - Server validation? Prevent cross-origin stuff
	console.log("Requesting File Path...");

	// create new form container
	var formData = new FormData();
	formData.append("retrieval_id", uniqueId);

	// make sure the unique id is correct
	$.ajax({
		type: "POST",
		// url of script on the server
		url: "http://130.111.220.27/~kfowlie/cross_drop/file_url_request.php",
		data: formData,
		// dataType: "json",
		processData: false,
		contentType: false,
		// handle AJAX errors
		error: errorHandler,

		xhr: function() {
		        var xhr = new window.XMLHttpRequest();
		        xhr.addEventListener("progress", function(evt) {
		           if (evt.lengthComputable) {
		               // Do something with download progress
		               var percentComplete = evt.loaded / evt.total;
		               updateDownloadProgress(Math.round(percentComplete * 100));
		           }
		        }, false);

		        return xhr;
		    }
		}).done(function(data) {
			// determine if the server found a match
			if(data == "0 results") {
				// the code provided wan't found
				console.log("The given code was not found in the database.")
				// TODO - add user feedback here
			}else {
				// we found the file, download it
				var path = "http://130.111.220.27/~kfowlie/cross_drop/" + data;
				console.log("Downloading file...");
				chrome.downloads.download({
					url: path
				});
			}

			// allow user to hit download button again
			getManager.canGet = true;
		});
}

/*
 * Handle any AJAX errors.
 */
function errorHandler(jqXHR, exception) {
	if (jqXHR.status === 0) {
		console.log('A connection could not be established with the server. Verify Network.');
	} else if (jqXHR.status == 404) {
		console.log('Requested page not found. [404]');
	} else if (jqXHR.status == 500) {
		console.log('Internal Server Error. [500].');
	} else if (exception === 'parsererror') {
		console.log('Requested JSON parse failed.');
	} else if (exception === 'timeout') {
		console.log('Time out error.');
	} else if (exception === 'abort') {
		console.log('Ajax request aborted.');
	} else {
		console.log('Uncaught Error.\n' + jqXHR.responseText);
	}

	// if we have any errors, make sure the user can re-upload or download content
	giveManager.canGive = true;
	getManager.canGet = true;
}

/*
 * Main Function, called when the document is completely loaded.
 */
$(document).ready(function () {
	// clear file holder info
	// giveManager.setFile(null);	TODO - see if i need these
	// giveManager.setEvent(null);

	// bind the event handlers, wait for input
	bindHandlers();
});
