//////
///// Script for the CrossDrop system. Dedicated to detecting file drops.
////


//___ Globals ___//

// TODO - fix this issue
// temporary file holder system
var fileHolder = {
	currentFile: null,
	fileEvent: null,

	// File getters/ setters
	setFile : function (file) {
		this.currentFile = file;
	},
	getFile : function () {
		return this.currentFile;
	},
	// Event getter/setters
	setEvent : function (e) {
		this.fileEvent = e;
	},
	getEvent : function () {
		return this.fileEvent;
	}
}

//___ Methods ___//

/*
 * Set dragging event listeners to the drop zone.
 */
function bindDragHandlers () {
	$(".dropzone-text").on("dragover", function (e) {
		e.preventDefault();
		e.stopPropagation();

		// provide user feedback
		$(".dropzone-text").css("background-color", "Salmon");
	});

	$(".dropzone-text").on("dragcenter", function (e) {
		e.preventDefault();
		e.stopPropagation();
	});

	$(".dropzone-text").on("drop", function (e) {
		console.log("File Dropped...");
		if(e.originalEvent.dataTransfer) {
			if(e.originalEvent.dataTransfer.files.length) {
				e.preventDefault();
				e.stopPropagation();

				// save file information for later use (when user hits upload)
				fileHolder.setFile(e.originalEvent.dataTransfer.files[0]);
				// save event information for later use
				fileHolder.setEvent(e);

				// update the text placeholder
				updateGiveText(fileHolder.getFile());
				
				// only bind the button click if we have dropped a file
				$(".upload-button").on("click", function () {
					// upload the file with AJAX
					uploadFile(fileHolder.getEvent(), fileHolder.getFile());
				});
			}
		}
	});

	// TODO - fix mouse moving off screen color
	$("#lower-container").mouseout(function () {
		// back to original color
		$("#lower-container").css("background-color", "FloralWhite");
	});

	// set the click handler for the download button
	$(".download-button").on("click", function () {
		// TODO - make sure user entered a 6-digit code

		// get the file location from the database
		console.log("hey");
		chrome.downloads.download({
			url: "http://130.111.220.27/~kfowlie/cross_drop/files/goldfish.jpg"
		});
	});
}


/*
 * Update the text information to show the file name.
 */
function updateGiveText (file) {
	// Change drop location text to show the uploaded file name
	$(".dropzone-text").fadeOut("slow", function () {
		// change only the text inside the element
		// TODO - fix text wrapping of file name
		$(".dropzone-text").text(file.name);
		$(".dropzone-text").css("border", "none");
	});
	$(".dropzone-text").fadeIn();
}

/*
 * Update download progress.
 */
function updateDownloadProgress (progress) {
	// change the "Give It" text to reflect the current upload progress
	$(".dropzone-text").text(progress + "%");
}

/*
 * Update download progress.
 */
function updateGetText (retrievalCode) {
	// change the "Give It" text to reflect the current upload progress
	$(".number-input").attr("placeholder", retrievalCode);
}

/*
 * Upload the file to the database with AJAX.
 */
function uploadFile (event, file) {
	// TODO - Server validation? Prevent cross-origin stuff
	console.log("Starting the Upload Process");

	// create new form container
	var formData = new FormData();

	// stay on this page
	event.preventDefault();

	formData.append("file", file);
		$.ajax({
			type: "POST",
			// url of script on the server
			url: "http://130.111.220.27/~kfowlie/cross_drop/file_handler.php",
			data: formData,
			// dataType: "json",
			processData: false,
			contentType: false,
			// handle AJAX errors
			error: errorHandler,

			xhr: function() {
			        var xhr = new window.XMLHttpRequest();
			        xhr.upload.addEventListener("progress", function(evt) {
			            if (evt.lengthComputable) {
			                var percentComplete = evt.loaded / evt.total;
			                // Do something with upload progress
			                updateDownloadProgress(percentComplete * 100);
			            }
			       }, false);
			       xhr.addEventListener("progress", function(evt) {
			           if (evt.lengthComputable) {
			               var percentComplete = evt.loaded / evt.total;
			               // Do something with download progress
			               console.log(percentComplete * 100);
			           }
			       }, false);

			       return xhr;
			    }
			}).done(function(data) {
				// display retrieval code
				updateGetText(data);
			});
}

/*
 * Handle any AJAX errors.
 */
function errorHandler(jqXHR, exception) {
	if (jqXHR.status === 0) {
		console.log('Not connected. Verify Network.');
	} else if (jqXHR.status == 404) {
		console.log('Requested page not found. [404]');
	} else if (jqXHR.status == 500) {
		console.log('Internal Server Error [500].');
	} else if (exception === 'parsererror') {
		console.log('Requested JSON parse failed.');
	} else if (exception === 'timeout') {
		console.log('Time out error.');
	} else if (exception === 'abort') {
		console.log('Ajax request aborted.');
	} else {
		console.log('Uncaught Error.\n' + jqXHR.responseText);
	}
}

/*
 * Main Function, called when the document is completely loaded.
 */
$(document).ready(function () {
	// clear file holder info
	fileHolder.setFile(null);
	fileHolder.setEvent(null);
	// bind the handlers, wait for input
	bindDragHandlers();
});
